"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _lowcodeDesigner = require("@alilc/lowcode-designer");

require("./index.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var DesignerPlugin = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(DesignerPlugin, _PureComponent);

  function DesignerPlugin(props) {
    var _this;

    _this = _PureComponent.call(this, props) || this;
    _this.state = {
      componentMetadatas: null,
      library: null,
      extraEnvironment: null,
      renderEnv: 'default',
      device: 'default',
      locale: '',
      designMode: 'live',
      deviceClassName: '',
      simulatorUrl: null,
      requestHandlersMap: null
    };
    _this._mounted = true;

    _this.handleDesignerMount = function (designer) {
      var editor = _lowcodeEditorCore.globalContext.get('editor');

      editor.set('designer', designer);
      editor.emit('designer.ready', designer);
      editor.onGot('schema', function (schema) {
        designer.project.open(schema);
      });
    };

    _this.setupAssets();

    return _this;
  }

  var _proto = DesignerPlugin.prototype;

  _proto.setupAssets = /*#__PURE__*/function () {
    var _setupAssets = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var editor, assets, renderEnv, device, locale, designMode, deviceClassName, simulatorUrl, requestHandlersMap, components, packages, extraEnvironment, utils, state;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              editor = _lowcodeEditorCore.globalContext.get('editor');
              _context.prev = 1;
              _context.next = 4;
              return editor.onceGot('assets');

            case 4:
              assets = _context.sent;
              renderEnv = _lowcodeEditorCore.engineConfig.get('renderEnv') || editor.get('renderEnv');
              device = _lowcodeEditorCore.engineConfig.get('device') || editor.get('device');
              locale = _lowcodeEditorCore.engineConfig.get('locale') || editor.get('locale');
              designMode = _lowcodeEditorCore.engineConfig.get('designMode') || editor.get('designMode');
              deviceClassName = _lowcodeEditorCore.engineConfig.get('deviceClassName') || editor.get('deviceClassName');
              simulatorUrl = _lowcodeEditorCore.engineConfig.get('simulatorUrl') || editor.get('simulatorUrl'); // @TODO setupAssets 里设置 requestHandlersMap 不太合适

              requestHandlersMap = _lowcodeEditorCore.engineConfig.get('requestHandlersMap') || editor.get('requestHandlersMap');

              if (this._mounted) {
                _context.next = 14;
                break;
              }

              return _context.abrupt("return");

            case 14:
              components = assets.components, packages = assets.packages, extraEnvironment = assets.extraEnvironment, utils = assets.utils;
              state = {
                componentMetadatas: components || [],
                library: packages || [],
                utilsMetadata: utils || [],
                extraEnvironment: extraEnvironment,
                renderEnv: renderEnv,
                device: device,
                designMode: designMode,
                deviceClassName: deviceClassName,
                simulatorUrl: simulatorUrl,
                requestHandlersMap: requestHandlersMap,
                locale: locale
              };
              this.setState(state);
              _context.next = 22;
              break;

            case 19:
              _context.prev = 19;
              _context.t0 = _context["catch"](1);
              console.log(_context.t0);

            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 19]]);
    }));

    function setupAssets() {
      return _setupAssets.apply(this, arguments);
    }

    return setupAssets;
  }();

  _proto.componentWillUnmount = function componentWillUnmount() {
    this._mounted = false;
  };

  _proto.render = function render() {
    var editor = _lowcodeEditorCore.globalContext.get('editor');

    var _this$state = this.state,
        componentMetadatas = _this$state.componentMetadatas,
        utilsMetadata = _this$state.utilsMetadata,
        library = _this$state.library,
        extraEnvironment = _this$state.extraEnvironment,
        renderEnv = _this$state.renderEnv,
        device = _this$state.device,
        designMode = _this$state.designMode,
        deviceClassName = _this$state.deviceClassName,
        simulatorUrl = _this$state.simulatorUrl,
        requestHandlersMap = _this$state.requestHandlersMap,
        locale = _this$state.locale;

    if (!library || !componentMetadatas) {
      // TODO: use a Loading
      return null;
    }

    return /*#__PURE__*/_react["default"].createElement(_lowcodeDesigner.DesignerView, {
      onMount: this.handleDesignerMount,
      className: "lowcode-plugin-designer",
      editor: editor,
      designer: editor.get('designer'),
      componentMetadatas: componentMetadatas,
      simulatorProps: {
        library: library,
        utilsMetadata: utilsMetadata,
        extraEnvironment: extraEnvironment,
        renderEnv: renderEnv,
        device: device,
        locale: locale,
        designMode: designMode,
        deviceClassName: deviceClassName,
        simulatorUrl: simulatorUrl,
        requestHandlersMap: requestHandlersMap
      }
    });
  };

  return DesignerPlugin;
}(_react.PureComponent);

exports["default"] = DesignerPlugin;
DesignerPlugin.displayName = void 0;